#include <stdio.h>
#include <stdlib.h>
#include "thread/h/thread.h"

struct Tsd {
    int    i;
    double d;
    char   c;
    void*  p;
};

static thread_key_t tsd_key;

static void myfree(void* ptr) {
    thr_do_trace("destructor called on pointer %p", ptr);       
    delete (Tsd *) ptr;
}

static void bar() {
    thread_t me = thr_self();
    Tsd*     ptr;

    thr_getspecific(tsd_key, (void **) &ptr);

    if (ptr->i != (int)    me) { thr_do_trace("i is %d", ptr->i); }
    if (ptr->d != (double) me) { thr_do_trace("d is %g", ptr->d); }
    if (ptr->c != (char)   me) { thr_do_trace("c is %d", ptr->c); }
    if (ptr->p != (void *) me) { thr_do_trace("p is %p", ptr->p); }
}

static void* foo(void* junk) {
    thread_t me  = thr_self();
    Tsd*     ptr = new Tsd;
	unsigned i;

    ptr->i = (int)    me;
    ptr->d = (double) me;
    ptr->c = (char)   me;
    ptr->p = (void *) me;

    thr_setspecific(tsd_key, (void *) ptr);
    thr_do_trace("installed data, yielding to others");

    for (i = 0; i < 10; ++i) { 
        thr_yield(); 
    }

    bar();
    thr_do_trace("finishing, verify destructor on %p", ptr);
    return 0;
}

int main() {
	unsigned i;

    thr_keycreate(&tsd_key, myfree);
    thr_do_trace("tsd key = %u", tsd_key);

    for (i = 0; i < 10; ++i) {
        thr_create(0, 0, foo, 0, 0, 0);
    }
    for (i = 0; i < 10; ++i) {
        thr_join(0, 0, 0);
    }

    return 0;
}
